﻿import com.delfiweb.error.*//ErrorDispatcher

/**
* Crée les textes du menu XML
* 
* @class Parser
* @author DELOISON Matthieu
* @version 0.1
*/
class Parser
{
	private var _xml:String


	private static var _instance:Parser=null
	private var _isDebug
	private var _isLocal
	
	
	
	private function Parser()
	{
		_xml="";
		_isDebug=PMain.instance.isDebug
		_isLocal = PMain.instance.isLocal

		
	}
	
	public static function getInstance ():Parser
	{
		if(Parser._instance==null)
		{
			Parser._instance=new Parser()
		}
		return Parser._instance
	}
	
		
	
	
	/*----------------------------------------------------------*/
	/*------------- Décode le XML ------------------------------*/
	/*----------------------------------------------------------*/
	
	
	
	// fonction : décode le fichier XML des modes de paiement
	function parseXML (xml)
	{
		//if (_isDebug) (xml)
		// si le xml n'est pas défini 
	   if(!xml) { throw new DError ("Aucun paramètre n'a été transmis à la fonction.","parser",0); } 
	   // si il n'est pas du bon type 
	   //else if(typeof xml != "string") { throw new DError ("Le paramètre transmis n'est pas une chaîne","parser",0); } 
	   // a priori c'est bon 
	   else 
	   {
			XML.prototype.ignoreWhite = true
			var n = new XML(xml); 
			
			// si il est mal formé sur le premier noeud on se retrouve avec un xml vide 
			if(n.toString() == "") { throw new DError ("La chaine1 xml transmise est mal formé","parser",0); } 
			  
			// on va faire nos vrai tests sur le premier fils 
			var ficxml = n.firstChild; 
			// si le fils était malformé 
			if(ficxml.toString() == "") { throw new DError ("La chaine2 xml transmise est mal formé","parser",0); } 
			// on parse le noeud principal 
			switch(ficxml.nodeName) 
			{ 
				 case "image" :  
				 case "IMAGE" : 
				 
					
					Constant.DETAILSIMAGES = new Array()
					var valeur;
					var txtoption:String = "";

					for(var i=0;i<ficxml.childNodes.length;i++)
					{	
						valeur = ficxml.childNodes[i];

						var nom:String = valeur.attributes.nomimage;
						var urlimage:String = valeur.attributes.urlimage;
						var nomrepertoire:String = valeur.attributes.nomrepertoire;
						var vignette:Boolean = valeur.attributes.vignette;

						// parse le texte optionnel
						txtoption = valeur.childNodes.join("");						
						// ajout dans le tableau DETAILSMENU - objet
						Constant.DETAILSIMAGES[i] = new InfosPhoto (nom,
															urlimage,
															nomrepertoire,
															vignette,
															txtoption
															);	
						
					}	
					break;
					  
				default :  
					  throw new DError ("Cas non-répertorié - Images","parser",1); 
					  break;	  
			}
			
			
			ficxml = n.childNodes[1];
			switch(ficxml.nodeName) 
			{ 
				
				 case "repertoires" :  
				 case "REPERTOIRES" : 					
					var a = new Array();
					_global.Repertoires = new Array ();
					//_global.Strings = new Array ();
					for(var i=0;i<ficxml.childNodes.length;i++)
					{
						var fils = ficxml.childNodes[i]
						//trace ("fils n° "+i+" : "+fils+" ("+fils.nodeType+", "+fils.nodeName+")");
						
						if(fils.nodeType==1)
						{
							// récupère l'index du tableau
							var index = [fils.attributes.id];
							// récupère la chaine correspondante
							var tmp= fils.firstChild.nodeValue.split ("\\n").join ("\n")
							
							_global.Repertoires[index] = tmp;
						}
					}
					break;
					  
				default :  
					  throw new DError ("Cas non-répertorié - String","parser",1); 
					  break;	  
			}
			
			ficxml = n.lastChild; 
	
			switch(ficxml.nodeName) 
			{ 
				
				 case "texte" :  
				 case "TEXTE" : 					
					var a = new Array();
					_global.Strings = new Array ();
					//_global.Strings = new Array ();
					for(var i=0;i<ficxml.childNodes.length;i++)
					{
						var fils = ficxml.childNodes[i]
						//trace ("fils n° "+i+" : "+fils+" ("+fils.nodeType+", "+fils.nodeName+")");
						
						if(fils.nodeType==1)
						{
							// récupère l'index du tableau
							var index = [fils.attributes.id];
							// récupère la chaine correspondante
							var tmp= fils.firstChild.nodeValue.split ("\\n").join ("\n")
							
							_global.Strings[index] = tmp;
						}
					}
					break;
					  
				default :  
					  throw new DError ("Cas non-répertorié - String","parser",1); 
					  break;	  
			}
			PMain.instance.construct();
	   }
	   

	}
	
}
	