<?php
	
/**
 * @function : galerie photo
 * @author :	Matthieu DELOISON
 * @version : 2 (ajout de la cration des miniatures)
 * @date : 29/11/2005
 * @upadte : 08/01/2006
 * @notes : 
 * 	- ATTENTION : le flash peut lire des images jpg ou png mais  une condition. Toutes
 * les images du mme rpertoire doivent avoir les mme extensions. C'est  dire que dans le mme
 * rpertoire, on ne peut pas mlanger des images jpg et png.
 *
 *  - Le script de redimensionnement des images ncessite PHP 4.0.6 ainsi que la librarie GD 2.0.1.
 *
 */

// si clique sur "Enregistrer l'image sous..."
if(isset($_POST['image']))
{
	$s_fichier_img = $_POST['image'];
	$s_nom_image = $_POST['nomimage'];

	header("Content-disposition:attachment; filename=$s_nom_image");
	header("Content-Type:application/force-download");

	readfile($s_fichier_img);
	exit();
}
 
clearstatcache();

/*--- configuration des couleurs ---*/

// bien respect le code fourni dans l'exemple.
$s_couleurfond = "0x999999"; // la couleur du fond (la ou sont affichs les photos
$s_couleurfondtitre = "0xcccccc"; // la couleur du fond du grand titre
$s_couleurtitre = "#00ff66"; // la couleur du texte du grand titre
$s_couleurBouton = "0x93B289"; // la couleur des boutons
$s_couleutTxtBouton = "ffffff"; // la couleur du texte des boutons 
 
$s_nom_fichier_php = "index.php"; // le nom du fichier php qui contient le flash et les scripts (par dfaut index.php)
 
 
/*--- gnration du fichier xml ---*/

$s_xml = "";
$listeRepertoires = array();


// entre : le nom du rpertoire  scanner
// fonction : liste les images d'un rpertoire et met  jour le fichier xml
function listerIMG($s_nomrep_courant)
{
	global $s_xml;
	global $listeRepertoires;
	
	/*--- Liste des images du Rpertoire ---*/
	if( strlen($s_nomrep_courant) > 1 )
	{
		$repActu = opendir($s_nomrep_courant);
		
		// Scan du rpertoire
		while($scanimg=readdir($repActu)) 
		{
			// Fichier
			if(is_file($s_nomrep_courant."/".$scanimg)) 
			{

				// Verification de l'extension d'image
				$ext = strtolower(substr($scanimg, strrpos($scanimg, '.') + 1));
				//  modifier suivant l'extension des images du rpertoire
				//if (($ext=="PNG") || ($ext=="png")) 
				if (($ext=="jpg") || ($ext=="jpeg") || ($ext=="JPEG") || ($ext=="JPG") ) 
				{
					$nomrep = substr($s_nomrep_courant, 2);
					$s_param = explode(".", $scanimg);
					$nomimage = $s_param[0];
					
					/*--- cration des miniatures ---*/				
					$s_chemin_mini = substr($s_nomrep_courant, 2);
					$s_mini_img = $scanimg;
					
					// on ne redimensionne pas la miniature
					if( substr($s_mini_img, 0, 5) != "mini_" )
					{
					
						if( file_exists($s_chemin_mini."/mini_".$s_mini_img) )
						{
							//echo " le fichier existe : ".$s_chemin_mini."/mini_".$s_mini_img."<br>";
						}
						else
						{
							//echo "creation de la miniatures <br>";
							resize( $s_chemin_mini."/", $s_mini_img);
						}
						// mise  jour du fichier xml
						$s_xml .="<detail nomimage=\"".$nomimage."\" urlimage=\"".$s_nomrep_courant."/".$scanimg."\" nomrepertoire=\"".$nomrep."\" vignette=\"".$s_nomrep_courant."/mini_".$scanimg."\" ><p align='center'>Des commentaires optionnels)</p>
							   </detail>";
					}				

					// remplit le tableau des rpertoires
					array_push ($listeRepertoires, $nomrep);

				}
			}
		}
		closedir($repActu);
		return true;
	}
}


// entre : le nom du rpertoire (le chemin), le nom du fichier  redimensionner
// sortie : true or false
// fonction : redimensionne des images
function resize($s_chemin, $file)
{
    $size = getimagesize($s_chemin.$file);
    
    # getimagesize() retourne un tableau de 4 lments.
    # L'index 0 contient la largeur. L'index 1 contient la longueur. L'index 2
    # contient le type de l'image : 1 = GIF, 2 = JPG,
    # 3 = PNG, 5 = PSD, 6 = BMP.
    # L'index 3 contient la chane  placer dans les balises
    # HTML : "height=xxx width=xxx"
    # (source www.php.net)    
    
    //$dest_width = ($size[0]/6); //dtermine la taille de la miniature, ici l'on dsire quelles soient d'un sixime de leur taille normale
    //$dest_eight = ($size[1]/6);
 	$dest_width = 200;
    $dest_eight = 200;
	
    $src_img = imagecreatefromjpeg($s_chemin.$file);
    $dst_img = imagecreatetruecolor($dest_width,$dest_eight);

    imagecopyresampled($dst_img, $src_img, 0, 0, 0, 0, $dest_width, $dest_eight, $size[0], $size[1]); // la fonction qui redimensionne les photos
    imagejpeg($dst_img, $s_chemin."mini_".$file, 60);
    imagedestroy($src_img);
    imagedestroy($dst_img); 
	
	return true;   
}
 
$s_xml = "<?xml version=\"1.0\" encoding=\"utf-8\" ?>
";


/*--- Rcupre toutes les images d'un rpertoire ---*/
$s_xml .= "<image>

";

 // Rpertoire courant
$repcou = @$_GET["dir"];
if(!$repcou) $repcou = ".";


// Liste des dossiers
$dir = opendir($repcou);
// Scan du rpertoire
while($scan=readdir($dir)) 
{
	// Dossier sauf rpertoire courant
	if(is_dir($repcou."/".$scan)&&($scan!=".")) 
	{
		// Rpertoire parent
		if($scan=="..") 
		{
			// Lien vers le rpertoire parent
			if($repcou!=".") 
			{
				$tmp = strrpos($repcou,"/");
				$s_nomrep_courant = substr($repcou,0,$tmp);
			}
		} 
		else
		{
			$s_nomrep_courant = $repcou."/".$scan;
			$b_retour = listerIMG($s_nomrep_courant);
		}
	}
}
closedir($dir);

$s_xml .="</image>

";


/*--- Traitement des rpertoires --*/
$i_taille = sizeof($listeRepertoires);
$listeRep = array_unique ($listeRepertoires); // enlve les doublons du tableau
//print_r($listeRep);
$cpt = 0;
$s_xml .= "<repertoires>";
foreach ( $listeRep as $value ) 
{
   $s_xml .= "
		<t id=\"".$cpt."\">".$value."</t>";
	$cpt++;
}
	
$s_xml .= "
</repertoires>
";	


/*--- Les textes de la galerie flash --*/
$s_chargement = "Chargement du xml en cours...";

$s_xml .= "
<texte langue=\"FR\">
	<t id=\"0\">Suivant</t>
	<t id=\"1\">Prcdent</t>
	<t id=\"2\">Enregistrer l'image</t>
	<t id=\"3\">Retour  la liste des dossiers</t>

	<t id=\"20\">JudoClubVicomtois</t>
	
	<t id=\"90\">Chargement du xml en cours...</t>
	<t id=\"91\">Chargement de l'image en cours...</t>
	<t id=\"92\">Chargement en cours...</t>
	<t id=\"93\">Choisissez un dossier de photos</t>
	
	";


$nbre = rand(1000, 3505);
	
$s_xml .= "\n<t id=\"".$nbre."\">Kill Cache</t>
</texte>";	

/*--- mise en utf8 des caractres accentus ---*/
$s_accentues = array("","","","","","","","","");
$s_utf8 = array("&#224;","&#231;","&#232;","&#233;","&#234;","&#235;","&#238;","&#244;","&#249;");

$s_xml = str_replace($s_accentues, $s_utf8, $s_xml);


/*--- cration du fichier xml ---*/
$nomFic = "images.xml";
$fichier = fopen($nomFic,"w");
fwrite($fichier,$s_xml);
fclose($fichier);	
?>	

<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml"><head>
<meta http-equiv="Content-Language" content="fr">
<meta name="generator" content="PHPEdit">
<meta name="author" content="matthieu">
<META NAME="DESCRIPTION" CONTENT="Galerie photo dynamique en flash">
<META NAME="KEYWORDS" CONTENT="galerie,photo,flash,dynamique,gratuite">
<META NAME="robots" CONTENT="index">
<META NAME="REVISIT-AFTER" CONTENT="16 days">
<META NAME="Reply-to" CONTENT="didier30@yahoo.fr">
<meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1">
<title>Galerie Photo</title>
</head>


<body lang="fr">
<style type="text/css">
<!--
body,td,th {
	color: #FFFFFF;
}
body {
	background-color: #FFFFFF;
}
-->
</style>


	<div align="center">
	
		  <object classid="clsid:d27cdb6e-ae6d-11cf-96b8-444553540000" codebase="http://fpdownload.macromedia.com/pub/shockwave/cabs/flash/swflash.cab#version=6,0,0,0" width="790" height="505" align="middle">
			<param name="allowScriptAccess" value="sameDomain" >
		<PARAM NAME=movie VALUE="loader-galerie.swf?nomswf=galerie.swf&version=1&largeur=790&hauteur=505&urlxml=<? echo $nomFic; ?>&chaine1=<? echo $s_chargement; ?>&couleurfond=<? echo $s_couleurfond; ?>&couleurfondtitre=<? echo $s_couleurfondtitre; ?>&couleurtitre=<? echo $s_couleurtitre; ?>&couleurBtn=<? echo $s_couleurBouton; ?>&couleurTxtBtn=<? echo $s_couleutTxtBouton; ?>&nomficphp=<? echo $s_nom_fichier_php; ?>">
			<param name="quality" value="best" >
			<param name="bgcolor" value="#ffffff" >
			<embed src="loader-galerie.swf?nomswf=galerie.swf&version=1&largeur=790&hauteur=505&urlxml=<? echo $nomFic; ?>&chaine1=<? echo $s_chargement; ?>&couleurfond=<? echo $s_couleurfond; ?>&couleurfondtitre=<? echo $s_couleurfondtitre; ?>&couleurtitre=<? echo $s_couleurtitre; ?>&couleurBtn=<? echo $s_couleurBouton; ?>&couleurTxtBtn=<? echo $s_couleutTxtBouton; ?>&nomficphp=<? echo $s_nom_fichier_php; ?>" quality="best" bgcolor="#ffffff" width="790" height="505" align="middle" allowscriptaccess="sameDomain" type="application/x-shockwave-flash" pluginspage="http://www.macromedia.com/go/getflashplayer" />      
	</object>
	</div>
  </body>
</html>