﻿	/************************************************************ 
	/ Auteurs : DELOISON Matthieu								/ 
	/ Fonction : classe du formulaire gestion des dossiers		/
	/															/
	************************************************************/


// on fait tous les import nescessaires
import com.delfiweb.utils.*;
import com.delfiweb.error.*;
import com.delfiweb.forms.*;
import com.delfiweb.command.Delegate;


/**
* Construit le formulaire de Gestion des Dossiers
* 
* @class GestionDossier
* @author DELOISON Matthieu
* @version 0.1
*/
class GestionDossiers extends Form
{

	
	private var _main:MovieClip; 				// Pointeur sur le niveau	
	private var _niveau:Number;
	
	/*----- Variables globales -----------*/
	
	
	/*----- gestion des dossiers -----------*/			
	private var _dossiers:MovieClip;			
	private var _titre:MovieClip;			
				
	
	/*--- Movie Clips du formulaire ---*/
	private var _fondIMG:MovieClip;
	
	
	/*--- Variables de formulaires ---*/



	
	// le coonstructeur de la classe
	private function GestionDossiers ()
	{
		_main = this;
		_niveau = 30;
		
		_init();
		
	}
	
	
	// fonction : initialise l'indispensable
	function _init()
	{
		PMain.instance.onVisibleChange(true)
		_main.attachMovie("chargement","chargementIMG",8000,{_x:Constant.XCHARGEMENT, _y:Constant.YCHARGEMENT})
		_main.chargementIMG.contenu = _root.chaine1;
		_main.chargementIMG.barre._alpha = 0;
		_main.chargementIMG.txt._y += 15;
		construct();
	}
	
	
	// fonction : construction du formulaire
	function construct()
	{		
		
		if(_root.couleurfond != undefined )
		{
			var dmccouleur = new Color(_fondIMG);
			dmccouleur.setRGB(_root.couleurfond);	
		}
		
		if(_root.couleurfondtitre != undefined )
		{
			var dmccouleur = new Color(_titre._titreIMG);
			dmccouleur.setRGB(_root.couleurfondtitre);	
		}
		
		/*--- les dossier ---*/
		_dossiers = _main.createEmptyMovieClip("dossiers", _niveau++);
		
		if(_root.couleurtitre != undefined)
			_titre.contenu = "<font color=\""+_root.couleurtitre+"\">"+_global.Strings[93]+"</font>";
		else
			_titre.contenu = _global.Strings[93];
			

		var coordX:Number = 25;
		var coordY:Number = 70;
		var i:Number = 0;
		var nbPhotos:Number = 0;
		var cpt2:Number = 0;
		
		for(var cpt = 0; cpt < _global.Repertoires.length; cpt++)
		{
			if( cpt%7 == 0 && cpt!=0)
			{
				coordY += 110;
				coordX = 25;
			}
			
		
			_dossiers.attachMovie("polaroid","rep"+cpt, _niveau++ ,{_x:coordX,_y:coordY})
			
			coordX+=110;
			
			var numClip:String = "rep"+cpt;
			var nomDir:String = _global.Repertoires[cpt];
			nbPhotos = 0;
			
			for(cpt2 = 0; cpt2 < Constant.DETAILSIMAGES.length; cpt2++)
			{
				if(Constant.DETAILSIMAGES[cpt2].nomrepertoire == _global.Repertoires[cpt])
					nbPhotos++;
			}
			
			_dossiers["rep"+cpt].contenu = nomDir;
			_dossiers["rep"+cpt].txtnbphotos.nbcontenu = nbPhotos;
			//_dossiers["rep"+cpt].txtnbphotos._rotation = 45;
			_dossiers["rep"+cpt].onRelease = Delegate.create(this,_onBtnReleaseRep, nomDir,cpt,_global.Repertoires.length).getFunction();
			_dossiers["rep"+cpt].onRollOver = Delegate.create(this,_onRepRollOver, nomDir,numClip,cpt).getFunction();
			_dossiers["rep"+cpt].onRollOut = Delegate.create(this,_onRepRollOut, nomDir,cpt).getFunction();
			i++;

			if( i%3 == 0 && i!=0) i = 0;
		}
		
		_main.chargementIMG.removeMovieClip();
		PMain.instance.onVisibleChange(false)
	}
	
	
	/*--------------------------------------------------------------------------*/
	/*------------------- Action sur les boutons -------------------------------*/
	/*--------------------------------------------------------------------------*/
	
	function _onBtnReleaseRep(index:Array)
	{
		var numRep:Number = index[1];
		var nbRep:Number = index[2];
		
		Constant.NOMREPCHOISI = index[0];
		
		next(); // formulaire suivant
		
	}
	
	
	
	function _onRepRollOver(index:Array)
	{
		var nom:String = index[0];
		var clip:MovieClip = index[1];
		var numRep:Number = index[2];		
	}
	
	
	function _onRepRollOut(index:Array)
	{
		var numRep:Number = index[1];
	}
	
	
}