﻿	/**
	* @method addListener
	* entrée : obj (Object) L'objet écouteur
	* description : Ajoute un écouteur a notre objet
	*/
	public static function addListener (o:Object):Boolean
	{
		for(var i in _listeners)
		{
			if(_listeners[i] == o)
			{
				return false;
			}
		}
		_listeners.push(o);
		return true;
	}
	
	
	/**
	* @method removeListener
	* entrée : obj (Object) L'objet écouteur
	* description : Enleve un écouteur a notre objet
	*/
	public static function removeListener (o:Object):Boolean
	{
		for(var i in _listeners)
		{
			if(_listeners[i] == o)
			{
				_listeners.splice(Number(i),1);
				return true;
			}
		}
		return false;
	}
	
	
	/**
	* @method notifyListener
	* entrée : event (String) Le nom de l'évenement
	* entrée : obj (Object) L'objet évenement
	* description : Notifie un évenement à tous les écouteurs
	*/
	public static function notifyListeners (e:String, obj:Object):Void
	{
		for(var i in _listeners)
		{
			_listeners[i][e](obj);
		}
	}